unit editdata;

{dernieres modifs
8/08/00: Edouard :modification de Tdataeditform.ComboBox1DropDown
18/10/00: Edouard : ajout des procedures spectre.savetoPAXY et spectre.readfromPAXY }
{ MODIFICATIONS                                                                     }
{ mise a jour le 31.10.2000                                                         }
{ 13.12.00, FO : ajout d'une procdure "litSpectre1D" et "litSpectre2D" pour lire un spectre a partir du disque dur }
{ 13.12.00, FO : ajout d'une variable "integrale" pour l'integrale du spectre entre les deux curseurs                 }
{ 12.01.01: FO : dclaration const sreg='\PilotageManip';                                                             }
{                dclaration indexFichierKey='indexFichier';                                                          }
{                deux nouvelles procdures function GetIndexFichierCrt:integer;
{                                          procedure IncIndexFichierCrt;                                     }
{ 17.01.01: EL : petite modif sur spectre.readfromfile}
{ 18.02.01: FO : upgrade du type POINTS : ajot de l'information temporelle ou lambda                         }
{                modification du type spectre : data devient un tableau 3D: X,Y,LT                           }
{ consquences : modif de spectre.clear                                                                      }
{                modif de spectre.total : somme pour toutes les LT                                           }
{                modif de spectre.minmax : ne rend mnimax que pour LT = 0                                    }
{                      il faut prvoir un upgrade pour rendre minmax sur une tranche prdfinie              }
{                spectlist.addspectre(nom:string;X:integer;Y:integer;LT:integer):integer; **LT** doit etre indiqu }
{ 02.03.01: CL : ajout des oprations arithmtiques pas encore fini+correction  faire}
{ 05.06.01 : FO : ajout des oprations de coupes :
{                function CoupeHSpectre2D(name:string;yy :double) :spectre; { coupe horizontale suivant la droite d'ordonne y }
{                function CoupeVSpectre2D(name:string;xx :double) :spectre ; { coupe verticale suivant la droite d'ordonne x }
{                ainsi que des oprations de projection et intgrales                                                                  }
{                function ProjectionHSpectre2D(name:string;x1,x2 :double):spectre; { projection horizontale entre les droite x1 et x2 }
{                function ProjectionVSpectre2D(name:string;y1,y2 :double):spectre; { projection verticale suivant la droite d'ordonne x }
{                function IntegraleSpectre1D(x1,x2:double) :double; { somme entre les abscisses definies par x1 et x2 }
{                function IntegraleSpectre2D(x1,y1,x2,y2 :double) :double; { somme entre le rectangle defini par x1,y1 ,x2,y2 }
{                POUR LE MOMENT ne marche qu'avec les types 'raw'
{29.03.01 : EL   Nouvelle procedure de sauvegarde pour tous les spectres :                                 }
{                definition de nouveaux types: experimentalCondType et spectsave                           }
{                modification du Type spectre: + champs moniteur et ExpCondNbr + tableau  experimentalConditions }
{                creation de spectre.save et spectre.open                                                              }
{ 03.04.01 : FO :procedure de sauvegarde d'un spectre sous la forme d'un fichier ASCII                                 }
{                procedure spectre.saveToASCII(FileName:string;Comment:string);
{08.06.01 : EL : Creation de la procedue spectre.SetExpCond(nom:string;valeur:real)
                 cette procedure permet de creer des champs et de les modifier dans le tableau experimentalConditions
{12.08.01: EL :  ajout de spect[i].ExpCondNbr:=0; dans spectlist.addspectre
{14.06.01: EL :  Modification de spectlist.add pour tenir compte du changement du format spectre.                      }
{ ======================================================================================================== }
{ A FAIRE                                                                                                  }
{ RENOMMER les procedure AddSpectre et add pour eviter les confusions => NewSpectre et TransfertSpectre    }
{ faire le mnage dans les mthodes de spectList                       }
{ Probleme avec AddSpectre, verifier la compatibilte des tailles sinon message d'erreur }
{ la somme circulaire ne fonctionne pas correctement pour x0,y0 <> 64?64       }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  filectrl, StdCtrls, ExtCtrls, AxCtrls, OleCtrls, Parser10, Buttons, registry,
  Spin,math;

const
  sreg='\PilotageManip';
  indexFichierKey='indexFichier';

const defaultdir='c:\spe'; { DOIT DISPARAITRE => passage dans la base de registre }
      totalspectre=30;

type  {utilis pour l'enregistrement au format PAXY}
    Paxy=record
    entete:array[0..255] of char;
    data:array [0..127,0..127] of word;
end;

{ type point lmentaire contenant toutes les informations possibles }
type
    pointsOLD=record
    mon:real;      { moniteur }
    x:real;        { coordonne X, qui peut etre un angle ou un vecteur qx }
    y:real;        { coordonne Y, qui peut etre un angle ou un vecteur qx }
    z:real;        { en gnral intensit mesure                          }
    end;
    points=record
    mon:real;      { moniteur }
    x:real;        { coordonne X, qui peut etre un angle ou un vecteur qx }
    y:real;        { coordonne Y, qui peut etre un angle ou un vecteur qx }
    lt:real;       { coordonne temporelle : longueur d'onde ou temps      }
    z:real;        { en gnral intensit mesure                          }
    end;

type
    pspectsav=^spectsav;
    spectsav=record
    X:integer;
    Y:integer;
    nom:string[20];
    com:string[100];
    typX:string[6];
    typY:string[6];
    indexX:integer;
    indexY:integer;
{    data:array of array of pointsOLD; }
end;
{**********************************
    NOUVEAUX TYPES POUR SAUVEGARDE}
Type
    experimentalCondType=record
                           name:string[20];
                           value:real;
                           end;
Type
    spectsave=record  {en-tete du nouveau format de sauvegarde}
    nom:string[20];
    comment:string[255];
    moniteur:real;
    X,Y,LT:integer; { tailles des diffrentes dimensions }
    ExpCondNbr:integer;  { nbr de cond exp. }
    typeX,typeY,typeLT:string[6];
    end;

type
    spectre=class(tobject)
    private
    fX:integer;fY:integer;fLT:integer;
    fnom:string;
    fcom:string;
    ftypX:string;ftypY:string;ftypLT:string;
    { Dclarations prives }
    protected
    public
    data:array of array of array of points;
    moniteur:real; {moniteur du spectre}
    indexX,indexY,indexLT:integer;         { que reprsentent ces paramtres ??? }
    ExpCondNbr:integer;  { nombre de cond exp. }
    experimentalConditions:array of ExperimentalCondType;   {champs libres pour conditions experimentales}
    property X:integer read fx write fx;           { taille de data dimension 1 }
    property Y:integer read fy write fy;           { taille de data dimension 2 }
    property LT:integer read flt write flt;        { taille de data dimension 3 }
    property Nom:string read fnom write fnom;
    property Comment:string read fcom write fcom;
    property typeX:string read ftypX write ftypX;  { raw OU mm OU nm-1 OU deg }
    property typeY:string read ftypY write ftypY;  { raw OU mm OU nm-1 OU deg }
    property typeLT:string read ftypLT write ftypLT; { nm OU sec } { lambda en nm ou temps en secondes }
    // ==================================== //
    // gestion des spectres
    procedure clear; { mise  zro de tous les points du spectre }
    procedure minmax(var min:real;var max:real);
    procedure savetofile(filename:string);
    procedure save(FileName:string);
    procedure open(FileName:string);
    procedure saveToASCII(FileName:string);
    procedure readfromfile(filename:string);
    procedure savetoPAXY(path,titre,nom,date,heure,temps:string;index:integer);
    procedure readfromPAXY(filename :string;var titre,nom,date,heure,temps:string);
    procedure SetExpCond(nom:string;valeur:real); {modifie le tableau experimentalConditions}
    // ==================================== //
    // oprations de projection
    function CoupeHSpectre2D(name:string;yy :double) :spectre; { coupe horizontale suivant la droite d'ordonne y }
    function CoupeVSpectre2D(name:string;xx :double) :spectre ; { coupe verticale suivant la droite d'ordonne x }
    function ProjectionHSpectre2D(name:string;x1,x2 :double):spectre; { projection horizontale entre les droite x1 et x2 }
    function ProjectionVSpectre2D(name:string;y1,y2 :double):spectre; { projection verticale suivant la droite d'ordonne x }
    function IntegraleSpectre1D(x1,x2:double) :double; { somme entre les abscisses definies par x1 et x2 }
    function IntegraleSpectre2D(x1,y1,x2,y2 :double) :double; { somme entre le rectangle defini par x1,y1 ,x2,y2 }
    { renommer } function total:real;
    Function SommeCirculaireSpectre2D(name:string;x0,y0,pas :double) :spectre; { somme circulaire }
    function SommePetitsAngles(name,nomMasque:string;x0,y0,npoints,lambda,delta,dist:double):spectre; { somme circulaire }
    // ==================================== //
    //masques de spectres
    function MasqueRectInt(x1,y1,x2,y2 :double;name: string) :spectre ; { masque de rectangle intrieur }
    function MasqueRectExt(x1,y1,x2,y2 :double;name: string) :spectre ; { masque de rectangle extrieur }
    function MasqueCircInt(x0,y0,x1,y1 :double;name: string) :spectre ;
    function MasqueCircExt(x0,y0,x1,y1 :double;name: string) :spectre ;
    function SommeCirculaireMask(Mask:spectre;Name:string;x0,y0,pas :double) :spectre; { somme circulaire avec un mask}
    // ==================================== //
end;

type    { liste de spectres }
    spectlist=class(tobject)
    protected
    procedure free; { verifier si c'est bien ecrit }
    public
    spect:array[1..totalspectre] of spectre;
    procedure createframe;   { A FAIRE DISPARAITRE }
    { CHANGER LE NOM }
    function addspectre(nom:string;X:integer;Y:integer;LT:integer):integer; { CREATION d'un nouveau spectre dans la liste et suppression si il existe deja un spectre de meme nom }
    { CHANGER LE NOM }
    procedure add(spec:spectre);          { ajout d'un spectre daje existant  la lsite des spectres }
    { ameliorer la cohrence des noms des procdures }
    { de dbarrasser de deleteSpectre ou la passer en private au moins }
    procedure deletespectre(ind:integer); { suppression d'un spectre de la liste }
    procedure delete(nom:string); { suppression d'un spectre de la liste avec comme paramtre d'entre le nom string du spectre }
    procedure clear(nom:string);          { suppression d'un spectre de la liste }
    function indexof(nom:string):integer; { rend l'indice d'un spectre  partir de son nom string }
    procedure saveall;
    { cette procedure devrait etre une methode de spectre par de spectList !!!! }
    procedure addpt(nom:string;x,y,lt,z,mon:extended);
    { function obscure }
    { commentaires incomprhensibles ! }
    { quoi rentre, quoi sort ?!?     }
    function parsechaine(s:string):boolean;{traite la chane du type nom3=f(nom1,nom2)}
    //---------------------------------------------------------------//
    // oprations arithmtiques sur les spectres
    function Addition(nom1,nom2,nom3:string):boolean;{nom1+nom2=nom3}
    function Soustraction(nom1,nom2,nom3:string):boolean;{nom1-nom2=nom3}
    function Multiplication(nom1,nom2,nom3:string):boolean;{nom1*nom2=nom3, point par point}
    function Division(nom1,nom2,nom3:string):boolean;{nom1/nom2=nom3, point par point}
    function ScalAdd(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1+scalaire}
    function ScalSub(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1-scalaire}
    function ScalMult(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1*scalaire}
    function ScalDiv(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1/scalaire}
    //--------------------------------------------------------------//

    //--------------------------------------------------------------//
end;

type
  Tdataeditform = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Parser1: TParser;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    OpenDialog1: TOpenDialog;
    X: TLabel;
    EditX: TEdit;
    Label1: TLabel;
    EditY: TEdit;
    Label2: TLabel;
    EdittypX: TEdit;
    Label3: TLabel;
    EdittypY: TEdit;
    Label4: TLabel;
    Editnom: TEdit;
    Label5: TLabel;
    Editcom: TEdit;
    Label6: TLabel;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure F1Book1EndEdit(Sender: TObject; var EditString: WideString;
      var Cancel: Smallint);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure EdittypXChange(Sender: TObject);
    procedure EdittypYChange(Sender: TObject);
    procedure EditnomChange(Sender: TObject);
    procedure EditcomChange(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);


  private
    { Dclarations prives}
    unddeud:boolean;
  public
  procedure traitchaine(s:string);
  procedure sauve(i:integer;nom:string);
  procedure litSpectre1D(s:string);
  procedure litSpectre2D(s:string);

    { Dclarations publiques}
  end;

function fexis(nomf:string):boolean;
function GetIndexFichierCrt:integer;
procedure IncIndexFichierCrt;

var
  dataeditform: Tdataeditform;
  und:spectlist;    { liste de spectres 1D }
  deuxd:spectlist;  { liste de spectres 2D }
  troisd:spectlist; { liste de spectres 3D }
{ index frame doit disparaitre a terme }
  indexframe: array[1..16] of integer; {fait la correspondance entre le numero de frame et l'index du spectre}
  integrale:string; { integale du spectre en cours entre les curseurs }
  regis:tregistry;  { pointeur sur la base de registre }

implementation

uses BoiteNoire;

{ verificatiuon si un fiochier existe deja sur le disque }
{ INPUT : nom complet du fichier avec chemin             }
{ OUPUT : oui/non                                        }
function fexis(nomf:string):boolean;
        var
        fich:file;
        begin
        {$I-}
        assignfile(fich,nomf);
        reset(fich);
        closefile(fich);
        {$I+}
        fexis:=(IOresult=0) and (nomf<>'');
        end;

{ lecture de l'index courant du spectre  sauvegarder }
{ INPUT : none                                        }
{ OUTPUT : l'index du dernier spectre sauvegard      }
{ REM    : pas de modif de la base de registre        }
function GetIndexFichierCrt:integer;
var tf:boolean;
    id:integer;
begin
   id:=-1;
   regis:=tregistry.create;
   tf:=regis.openkey(sreg,true);
   if tf then
   begin
      id:=regis.readinteger(indexFichierKey);
   end;
   regis.free;
   result:=id
end;

{ incrmentation de l'index courant du spectre  sauvegarder }
{ le comptage boucle de 1000  9999                          }
{ on laisse tomber 1  999 pour ne pas  avoir  formater    }
{ INPUT : none                                        }
{ OUTPUT : l'index du fichier est incrment          }
{ REM    : si l'index arrive  10000 on revient  1000}
{          on garde toujours un nombre  4 chiffres pour des problmes de formatage }
procedure IncIndexFichierCrt;
var tf:boolean;
    id:integer;
begin
   regis:=tregistry.create;
   tf:=regis.openkey(sreg,true);
   if tf then
   begin
      id:=regis.readinteger(indexFichierKey);
      inc(id);if id=10000 then id:=1000;
      regis.writeinteger(indexFichierKey,id);
   end;
   regis.free;
end;

{$R *.DFM}

{ =============================================== }
{ oprations de gestion des SPECTRES              }

{---------------spectre---------------------------}
{ mise a zero de tous les points                  }
{ pas de changement de taille                     }
procedure spectre.clear;
var
i,j,k:integer;
begin
for i:=0 to X-1 do
for j:=0 to Y-1 do
for k:=0 to LT-1 do begin
data[i,j,k].x:=0;data[i,j,k].y:=0;data[i,j,k].lt:=0;data[i,j,k].z:=0;data[i,j,k].mon:=1;
end;
indexX:=0;indexY:=0;indexLT:=0
end;


{ *************************************** }
{ rend minmax d'un spectre 1D ou 2D       }
{ mais uniquement pour la tranche LT = 0  }
procedure spectre.minmax(var min:real;var max:real);
var
  i,j:integer;
begin
  min:=data[0,0,0].z;max:=data[0,0,0].z;
  for i:=0 to X-1 do
  for j:=0 to Y-1 do begin
  if min>data[i,j,0].z then min:=data[i,j,0].z;
  if max<data[i,j,0].z then max:=data[i,j,0].z;
  end;
end;

{***************************************
modifi le 8/06
filename = chemin+nom sans extension}
{ AMELIORER LA SUAVEGARDE AVEC LT<>0                  }
{ pour le moement ne sauvegarde que la tranche LT = 0 }
procedure spectre.SaveToFile(FileName: string);
var
fa:pspectsav;
fich:file of spectsav;
fich1:file of points;
fich2:file of real;
p:points;
i,j:integer;
filetot:string;
u:real;
begin
fa:=new(pspectsav);
fa.X:=X;fa.Y:=Y;
fa.indexX:=indexX;fa.indexY:=indexY;
fa.com:=comment;fa.nom:=nom;
fa.typX:=typeX;fa.typY:=typeY;
p.mon:=1;p.x:=0;p.y:=0;p.z:=0;u:=0;
if typex<>'raw' then
   begin
   filetot:=filename+'.spe';
   if fexis(filetot) then
      begin
      i:=1;
      filetot:=filename+inttostr(i)+'.spe';
      while fexis(filetot)do
            begin
            i:=i+1;
            filetot:=filename+inttostr(i)+'.spe';
            end;
      end;
   assignfile(fich,filetot);
   assignfile(fich1,filetot);
   rewrite(fich1);
   for i:=1 to 200 do write(fich1,p);{blanc}
   for i:=0 to X-1 do
   for j:=0 to Y-1 do write(fich1,data[i,j,0]);
   boitnoir.receivetext('sauvegarde sous '+filetot);
   closefile(fich1);
   reset(fich);
   write(fich,fa^);
   closefile(fich);
   end
else
    begin
    filetot:=filename+'.raw';
    if fexis(filetot) then
       begin
       i:=1;
       filetot:=filename+inttostr(i)+'.spe';
       while fexis(filetot)do
          begin
          i:=i+1;
          filetot:=filename+inttostr(i)+'.spe';
          end;
       end;
    assignfile(fich,filetot);
    assignfile(fich2,filetot);
    rewrite(fich2);
    for i:=1  to 200 do write(fich2,u);{blanc}
    for i:=0 to X-1 do
    for j:=0 to Y-1 do write(fich2,data[i,j,0].z);
    closefile(fich2);
    reset(fich);
    write(fich,fa^);
    closefile(fich);
    end;
dispose(fa);
end;

{***************************************}
{ ne lit que les spectres avec LT = 0    }
{ A AMELIORER                            }
procedure spectre.readfromfile(filename:string);
var
fa:pspectsav;
fich:file of spectsav;
fich1:file of points;
fich2:file of real;
p:points;
i,j:integer;
u:real;
begin
fa:=new(pspectsav);
assignfile(fich,filename);
assignfile(fich1,filename);
assignfile(fich2,filename);
reset(fich);
read(fich,fa^);
X:=fa.X;Y:=fa.Y;
comment:=fa.com;{nom:=fa.nom;}
typeX:=fa.typX;typeY:=fa.typY;
indexX:=fa.indexX;indexY:=fa.indexY;
setlength(data,X,Y,1);
closefile(fich);
if typeX<>'raw' then begin
reset(fich1);
for i:=1 to 200 do read(fich1,p);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do read(fich1,data[i,j,0]);
closefile(fich1);
end else begin
reset(fich2);
for i:=1 to 200 do read(fich2,u);{blanc}
for i:=0 to X-1 do
for j:=0 to Y-1 do read(fich2,data[i,j,0].z);
closefile(fich2);
{ATTENTION : format raw : indexX sert abusivement pour sauvegarder le moniteur!!}
data[0,0,0].mon:=indexX;
Lt:=1;
ExpCondNbr:=0;
setlength(experimentalConditions,ExpCondNbr);

end;
dispose(fa);
end;
{************************************* **************************************************************
NOUVELLE procedure de sauvegarde pour tous les spectres
En-tete : fichier Specsave,
+ suite de experimentalCondType
+ suite de real
principe: on ouvre un fichier de real, on ecrit des real sans importances pour laisser de la place a l'en-tete (322 octets)
et aux experimentalCondType. Puis on ferme le fichier de real et on ecrit par dessus les experimentalCondType
apres avoir laisse de la place pour l'en-tete
ATTENTION : par convention l'extension du fichier doit etre du type : 1Dxx, 2Dxx, 3Dxx selon la dim du spectre et l'etat de spin}
procedure spectre.save(FileName:string);
var temp:spectsave;
    fspec:file of spectsave;
    fdat:file of real;
    u:real;
    fcond:file of experimentalCondType;
    blanc:experimentalCondType;
    i,j,k:integer;
begin
{initialisation temp}
temp.nom:=nom;
temp.comment:=comment;
temp.moniteur:=moniteur;
temp.X:=X;
temp.Y:=Y;
temp.Lt:=Lt;
temp.typeX:=typeX;
temp.typeY:=typeY;
temp.typeLt:=typeLt;
temp.ExpCondNbr:=ExpCondNbr;
assignfile(fspec,Filename);
assignfile(fdat,Filename);
assignfile(fcond,FileName);
rewrite(fdat);

{** ecriture des Data}
{blanc en-tete (50 real = 400 octets)}
for i:=0 to 50 do write(fdat,u);
{blanc conditions experimentales (29 octets par condition/8 octets par real plus marge de secu}
for i:=0 to (round(ExpCondNbr*3.7)+10) do write(fdat,u);
{ecriture des echelles}
for i:=0 to X-1 do
    write(fdat,data[i,0,0].x);
for i:=0 to Y-1 do
    write(fdat,data[0,i,0].y);
for i:=0 to Lt-1 do
    write(fdat,data[0,0,i].Lt);
{ecriture des Datas}
for i:=0 to X-1 do
    for j:=0 to Y-1 do
        for k:=0 to Lt-1 do
        write(fdat,data[i,j,k].z);
closefile(fdat);

{** ecriture des conditions experimentales}
reset(fcond);
{blanc en-tete: 13*29=377 octets}
for i:=0 to 13 do write(fcond,blanc);
for i:=0 to ExpCondNbr-1 do
    write(fcond,experimentalConditions[i]);
closefile(fcond);
{** ecriture en-tete}
reset(fspec);
write(fspec,temp);
closefile(fspec);
end;


{************************************* ************************************************************* }
{ NOUVELLE procedure de sauvegarde en fichier ASCII                                                  }
{ INPUT : un nom de fichier pour la suavegarde sur le disque dur                                     }
{         une ligne de commentaire                                                                   }
{ OUTPUT : le format text basique X Y LT intensity                                                   }
{         si le format est 'raw' on sauvegarde les indices sinon les vraies valeurs de X,Y,LT        }
procedure spectre.saveToASCII(FileName:string);
var i,j,k:integer;
    fich:text;
    s:string;
begin
    assignfile(fich,FileName);
    rewrite(fich);
    writeln(fich,comment); { ecriture d'un commentaire en premire ligne }
    writeln(fich,FloatToStr(X)); { ecriture de la longeur du spectre 1D en deuxime ligne }
    writeln(fich,FloatToStr(Y)); { ecriture de la longeur du spectre 1D en deuxime ligne }
    writeln(fich,FloatToStr(LT)); { ecriture de la longeur du spectre 1D en deuxime ligne }
    for i:=0 to X-1 do
      for j:=0 to Y-1 do
         for k:=0 to LT-1 do
         begin
             s:='';
             if typeX='raw' then s:=intToStr(i)+#9 else s:=FloatToStr(data[i,j,k].x)+#9;
             if typeY='raw' then s:=s+intToStr(j)+#9 else s:=s+FloatToStr(data[i,j,k].y)+#9;
             if typeLT='raw' then s:=s+intToStr(k)+#9 else s:=s+FloatToStr(data[i,j,k].lt)+#9;
             writeln(fich,s+FloatToStr(data[i,j,k].z));
         end;
    closefile(fich);
end;


{************************************* **************************************************************
NOUVELLE Procedure de lecture de spectre :
le nom du spectre n'est pas charge (le spectre appellant cette methode garde son propre nom
initialisation des tailles de tableau et des champs x, y et lt}
procedure spectre.open(FileName:string);
var temp:spectsave;
    fspec:file of spectsave;
    fdat:file of real;
    u:real;
    fcond:file of experimentalCondType;
    blanc:experimentalCondType;
    i,j,k:integer;
begin
assignfile(fspec,FileName);
assignfile(fdat,FileName);
assignfile(fcond,FileName);
{** lecture en tete}
reset(fspec);
read(fspec,temp);
closefile(fspec);
{nom:=temp.nom;}
comment:=temp.comment;
moniteur:=temp.moniteur;
X:=temp.X;
Y:=temp.Y;
Lt:=temp.Lt;
typeX:=temp.typeX;
typeY:=temp.typeY;
typeLt:=temp.typeLt;
ExpCondNbr:=temp.ExpCondNbr;
{***lecture Datas}
setlength(data,X,Y,Lt);
reset(fdat);
{blanc en tete}
for i:=0 to 50 do read(fdat,u);
{blanc conditions experimentales}
for i:=0 to (round(ExpCondNbr*3.7)+10) do read(fdat,u);
{lecture Datas}
for i:=0 to X-1 do
    read(fdat,data[i,0,0].x);
for i:=0 to Y-1 do
    read(fdat,data[0,i,0].y);
for i:=0 to Lt-1 do
    read(fdat,data[0,0,i].Lt);
for i:=0 to X-1 do
    for j:=0 to Y-1 do
        for k:=0 to Lt-1 do
        read(fdat,data[i,j,k].z);
closefile(fdat);
{** lecture conditions experimentales}
setlength(experimentalConditions,ExpCondNbr);
reset(fcond);
{blanc en tete}
for i:=0 to 13 do read(fcond,blanc);
for i:=0 to ExpCondNbr-1 do
    read(fcond,experimentalConditions[i]);
closefile(fcond);
{remplissage des echelles}
for i:=0 to X-1 do
    for j:=0 to Y-1 do
        for k:=0 to Lt-1 do
            begin
            data[i,j,k].x:=data[i,0,0].x;
            data[i,j,k].y:=data[0,j,0].y;
            data[i,j,k].lt:=data[0,0,k].lt;
            end;
end;
{***********************************************
enregistre une spectre 2D Raw 128*128 (format PAPOL) au format paxy
path: chemin complet termin par \
titre : titre de la manip 6 caractres,
nom : nom de l'echantillon 6 caractres,
date : 10 caractres
heure : 8 caractres
temps : temps de comptage 6 caractres
mon : moniteur 8 caractres
index : numero du fichier PAXY 4 caractres}
procedure spectre.savetoPAXY(path,titre,nom,date,heure,temps:string;index:integer);
var i,j,dataint:integer;
    temp,filename:string;
    f:file of paxy;
    dbyte:word;
    fort,faible:byte;
    paxytemp:paxy;
begin
{******  creation de la tete du fichier PAXY}
{initialisation}
for i:=0 to 255 do
        paxytemp.entete[i]:='1';
{n fichier}
paxytemp.entete[0]:='X';
paxytemp.entete[1]:='Y';
temp:=inttostr(index);
for j:=2 to 5 do
    if j<= 5-length(temp) then
       paxytemp.entete[j]:='0'
    else  paxytemp.entete[j]:=temp[j+length(temp)-5];
{titre manip}
for j:=1 to 6 do
    if j>length(titre) then
       paxytemp.entete[j+5]:=' '
    else
        paxytemp.entete[j+5]:=titre[j];
{nom echantillon}
for j:=1 to 12 do
    if j>length(nom) then
       paxytemp.entete[j+11]:=' '
    else
        paxytemp.entete[j+11]:=nom[j];
{temps de comptage}
for j:=1 to 6 do
    if j>length(temps) then
       paxytemp.entete[j+23]:=' '
    else
        paxytemp.entete[j+23]:=temps[j];
{moniteur}
temp:=inttostr(trunc(data[0,0,0].mon));
for j:=1 to 8 do
    if j<=8-length(temp) then
       paxytemp.entete[29+j]:='0'
    else
        paxytemp.entete[29+j]:=temp[length(temp)-8+j];
{date}
for j:=1 to 10 do
    if j>length(date) then
       paxytemp.entete[j+37]:=' '
    else
        paxytemp.entete[j+37]:=date[j];
{heure}
for j:=1 to 8 do
    if j>length(heure) then
       paxytemp.entete[j+47]:=' '
    else
        paxytemp.entete[j+47]:=heure[j];
{commentaires}
for j:=67 to 255 do
    if (j-66)>length(comment) then
       paxytemp.entete[j]:=' '
    else
        paxytemp.entete[j]:=comment[j-66];

{******  sauvegarde des datas avec inversion poids fort poids faible}
for i:=0 to 127 do
	for j:=0 to 127 do
	begin
	dataint:=trunc(data[j,127-i,0].Z);
        fort:=dataint div 256;
        faible:=dataint mod 256;
        dbyte:=faible*256+fort;
	paxytemp.data[i,j]:=dbyte;
	end ;
{****** enregistrement}
filename:=path+copy(paxytemp.entete,0,6)+'.dat';
assignfile(f,filename);
rewrite(f);
write(f,paxytemp);
closefile(f);
end;

{***********************************************
lit un spectre au format PAXY}
procedure spectre.readfromPAXY(filename :string;var titre,nom,date,heure,temps:string);
var i,j,dataint:integer;
    temp:string;
    f:file of paxy;
    dbyte:word;
    fort,faible:byte;
    paxytemp:paxy;

begin
{***** lecture}
assignfile(f,filename);
reset(f);
read(f,paxytemp);
closefile(f);

{**** extraction tete}
titre:=copy(paxytemp.entete,7,6);
nom:=copy(paxytemp.entete,13,12);
temps:=copy(paxytemp.entete,25,6);
temp:=copy(paxytemp.entete,31,8);
data[0,0,0].mon:=strtofloat(temp);
date:=copy(paxytemp.entete,39,10);
heure:=copy(paxytemp.entete,49,8);
comment:=copy(paxytemp.entete,68,189);

{**** extraction data}
for i:=0 to 127 do
	for j:=0 to 127 do
	begin
        dataint:=paxytemp.data[i,j];
        fort:=dataint div 256;
        faible:=dataint mod 256;
        dbyte:=faible*256+fort;
        data[j,127-i,0].Z:=dbyte;
	end ;

end;                          

{***********************************************
Modifie la liste de conditions exprimentales, avec creation du champ si il n'existe pas
INPUT : nom : nom de la condition exprimentalle
        valeur : valeur a affecter
OUPUT : tableau experimentalConditions
        entier ExpCondNbr}
procedure spectre.SetExpCond(nom:string;valeur:real);
var i,index:integer;
begin
index:=-1;
if ExpCondNbr<>0 then  {recherche du champ nom}
   for i:=0 to ExpCondNbr-1 do
       if experimentalConditions[i].name=nom then index:=i;
if index=-1 then
   begin  {le champ nom n'existe pas : creation}
   ExpCondNbr:=ExpCondNbr+1;
   setlength(experimentalConditions,ExpCondNbr);
   index:=ExpCondNbr-1;
   experimentalConditions[index].name:=nom;
   end;
{affectation de la nouvelle valeur}
experimentalConditions[index].value:=valeur;
end;

// ==================================== //
// oprations de projection

{ on fait au plus rapide pour le moment }
{ INPUT : index de la ligne suivant laquelle on veut couper }
{ OUTPUT : un spectre
{ REM : version definitive : vraie valeur y                 }
{       + il faut verifier si on a affaire  un sectre 2D ! }
{ on prend toujours la coupe en LT = 0                      }
{ il y a des problmes parce que les champs .x et .y ne sont parfois pas bien initialiss }
{ VERSION PROPRE : trouver a quelle ligne Y correspond la valeur yy                       }
{ puis faire la coupe                                                                     }
{ dans x, mettre une vraie valeur x ou tester si on travaille en "raw"                    }
function spectre.CoupeHSpectre2D(name:string;yy :double) :spectre; { coupe horizontale suivant la droite d'ordonne y }
var coupe:spectre;
    i, j:integer;
begin
   coupe:=spectre.create;
   coupe.nom:=name;
   coupe.X:=X;coupe.Y:=1;coupe.LT:=1;
   coupe.typeX:=typeX;
   setlength(coupe.data,X,1,1);
   Coupe.ExpCondNbr:=0;
   coupe.clear;
   for i:=0 to X-1 do
        if typeX='raw'
        then begin
                coupe.data[i,0,0].x:=i;
                coupe.data[i,0,0].z:=data[i,round(yy),0].z;
             end
        else begin
                coupe.data[i,0,0].x:=data[i,round(yy),0].x;
                coupe.data[i,0,0].z:=data[i,round(yy),0].z;
             end;
   result:=coupe;
end;
{**************
}
function spectre.CoupeVSpectre2D(name:string;xx :double) :spectre ; { coupe verticale suivant la droite d'ordonne x }
var coupe:spectre;
    i:integer;
begin
   coupe:=spectre.create;
   coupe.nom:=name;
   coupe.X:=Y;coupe.Y:=1;coupe.LT:=1;
   coupe.typeX:=typeX;
   Coupe.ExpCondNbr:=0;
   setlength(coupe.data,Y,1,1);
   coupe.clear;
   for i:=0 to Y-1 do
        if typeX='raw'
        then begin
                coupe.data[i,0,0].x:=i;
                coupe.data[i,0,0].z:=data[round(xx),i,0].z;
             end
        else begin
                coupe.data[i,0,0].x:=data[round(xx),i,0].y;
                coupe.data[i,0,0].z:=data[round(xx),i,0].z;
             end;
   result:=coupe;
end;
{**************
}
function spectre.ProjectionHSpectre2D(name:string;x1,x2 :double):spectre; { projection horizontale entre les droite x1 et x2 }
var coupe:spectre;
    i,j:integer;
begin
   coupe:=spectre.create;
   coupe.nom:=name;
   coupe.X:=Y;coupe.Y:=1;coupe.LT:=1;
   coupe.typeX:=typeX;
   setlength(coupe.data,Y,1,1);
   Coupe.ExpCondNbr:=0;
   coupe.clear;
   for i:=0 to Y-1 do
   if typeY='raw'
        then begin
             coupe.data[i,0,0].x:=i;
             for j:=round(x1) to round(x2) do
                begin coupe.data[i,0,0].z:=coupe.data[i,0,0].z+data[j,i,0].z; end
             end
        else begin
             coupe.data[i,0,0].x:=data[0,i,0].x;
             for j:=round(x1) to round(x2) do
                begin coupe.data[i,0,0].z:=coupe.data[i,0,0].z+data[j,i,0].z; end
             end;
   result:=coupe;
end;
{**************
}
function spectre.ProjectionVSpectre2D(name:string;y1,y2 :double):spectre; { projection verticale suivant la droite d'ordonne x }
var coupe:spectre;
    i,j:integer;
begin
   coupe:=spectre.create;
   coupe.nom:=name;
   coupe.X:=X;coupe.Y:=1;coupe.LT:=1;
   coupe.typeX:=typeX;
   setlength(coupe.data,X,1,1);
   Coupe.ExpCondNbr:=0;
   coupe.clear;
   for i:=0 to X-1 do
   if typeX='raw'
        then begin
             coupe.data[i,0,0].x:=i;
             for j:=round(y1) to round(y2) do
                begin coupe.data[i,0,0].z:=coupe.data[i,0,0].z+data[i,j,0].z; end
             end
        else begin
             coupe.data[i,0,0].x:=data[i,0,0].x;
             for j:=round(y1) to round(y2) do
                begin coupe.data[i,0,0].z:=coupe.data[i,0,0].z+data[i,j,0].z; end
             end;
   result:=coupe;
end;

{ INPUT: 2 intervalles d'intgration [x1,x2] et [y1,y2]  }
{        ces indices rfrent a l'indice de data si le type du spectre est 'raw'       }
{        sinon ils rfrent aux vrais indices dat.x et data.y          }
{ OUTPUT : l'integrale des coups                                       }
{ modifier la procdure pour qu'on puisse utiliser des spectres autres que 'raw' }
function spectre.IntegraleSpectre1D(x1,x2:double) :double; { somme entre les abscisses definies par x1 et x2 }
var i,j:integer;
    somme:double;
begin
     somme:=0;
     if typeX='raw'
     then for i:=round(x1) to round(x2) do somme:=somme+data[i,0,0].z
     else for i:=round(x1) to round(x2) do somme:=somme+data[i,0,0].z;
     result:=somme;
end;

{ INPUT: 2 intervalles d'intgration [x1,x2] et [y1,y2]  }
{        ces indices rfrent a l'indice de data si le type du spectre est 'raw'       }
{        sinon ils rfrent aux vrais indices dat.x et data.y          }
{ OUTPUT : l'integrale des coups                                       }
function spectre.IntegraleSpectre2D(x1,y1,x2,y2 :double) :double; { somme entre le rectangle defini par x1,y1 ,x2,y2 }
var i,j:integer;
    somme:double;
begin
     somme:=0;
     if typeX='raw'
     then for i:=round(x1) to round(x2) do
              for j:=round(y1) to round(y2) do somme:=somme+data[i,j,0].z
     else for i:=round(x1) to round(x2) do
              for j:=round(y1) to round(y2) do somme:=somme+data[i,j,0].z;
     result:=somme;
end;

{procdure de calcul circulaire                         }
{ INPUT: le nom du spectre , le centre du cercle, et le }
{        pas d'intgration                               }
{OUTPUT: un spectre und                                 }
{ il manque la normalisation par la surface             }
{ il faut allonger la taille du spectre 1D sinon problme }
function spectre.SommeCirculaireSpectre2D(name:string;x0,y0,pas :double) :spectre; { somme circulaire }
var coupe:spectre;
    i,j:integer;
    R: double;
    norm:array of integer;
    taille,Xmax:integer;
begin
   taille:=round(sqrt(X*X+Y*Y)+1); {taille du fichier a priori}
   setlength(norm,taille);
   coupe:=spectre.create;
   coupe.nom:=name;
   coupe.typeX:=typeX;
   setlength(coupe.data,taille,1,1);
   Coupe.ExpCondNbr:=0;
   coupe.clear;
   Xmax:=1; {taille reel du resultat}
   if (x0>=0) and (x0<=X) and (y0>=0) and (y0<=Y) then
   begin
   for i:=0 to X-1 do
       for j:=0 to Y-1 do
         if typeX='raw' then begin
           R:=sqrt(sqr(i-x0)+sqr(j-y0));
           coupe.data[round(R),0,0].x:=pas*round(R);
           if round(R)>Xmax then Xmax:=round(R);
           inc(norm[round(R)]);
           coupe.data[round(R),0,0].z:=coupe.data[round(R),0,0].z+data[i,j,0].z;
         end
         else begin
              end;
   Inc(Xmax);
   for i:=0 to Xmax-1 do
       begin
       if norm[i]<>0 then coupe.data[i,0,0].z:=coupe.data[i,0,0].z/norm[i];
       end;
   End;
   setlength(coupe.data,Xmax,1,1);
   coupe.X:=Xmax;
   coupe.Y:=1;
   coupe.Lt:=1;
   result:=coupe;
end;

{procdure de calcul Pour Diffusion aux petits angles                         }
{ INPUT: le nom du spectre , le centre du cercle, le nombre de points pour l'integration,
         la Longueur  d'onde (PAPOL=8), la taille des pixels en metre (PAPOL=0.005), la distance echantillon detecteur}
{le Calcul de q est fait sans approximation et corrige le tilt du detecteur. Il suppose que le detecteur tourne autour de l'echantillon,
l'angle de tilt peut donc etre calcule par les coordonnees du faisceau directe.                                    }
{OUTPUT: un spectre und                                 }

function spectre.SommePetitsAngles(name,nomMasque:string;x0,y0,npoints,lambda,delta,dist:double):spectre;
var coupe:spectre;
    i,j,vindMasque:integer;
    qmax,qvar,resol:real;
    norm:array of integer;
    taille,Xmax:integer;

    {fonction calcul de q en fonction des coordonnees du pixel
    INPUT : coordonnees du pixel
    OUTPUT : q en 1/A si lambda est donne en A}
    function q(i,j:integer):real;
       var angle,calcos:real;
       begin
          {calcul du cosinus de l'angle de diffusion}
          calcos:=((i-X/2)*(x0-X/2)*sqr(delta)+sqr(dist))/
          (sqrt(sqr((x0-X/2)*delta)+sqr(dist))*sqrt(sqr((i-X/2)*delta)+sqr((j-y0)*delta)+sqr(dist)));
          if calcos>1 then calcos:=1; {IMPORTANT : evite calcos>1 suite a Arrondis de calcul}
          angle:=arccos(calcos);
          result:=4*3.14159*sin(angle/2)/lambda; {calcul de q}
       end;


begin
{calcul du qmax}
qmax:=max(max(q(0,0),q(0,Y-1)),max(q(X-1,0),q(X-1,Y-1)));
resol:=npoints/qmax;
{Calcul de la taille max du resultat}
Xmax:=round(qmax*resol)+2;
setlength(norm,Xmax);
coupe:=spectre.create;
coupe.nom:=name;
coupe.typeX:='q';
setlength(coupe.data,Xmax,1,1);
Coupe.ExpCondNbr:=0;
coupe.clear;
Xmax:=1;
if (x0>=0) and (x0<=X) and (y0>=0) and (y0<=Y) then   {verification du centre}
   begin
   for i:=0 to X-1 do
       for j:=0 to Y-1 do
         if typeX='raw' then begin
            {ici manque test masque}
           qvar:=q(i,j);
           if round(qvar*resol)>Xmax then Xmax:=round(qvar*resol); {calcul de la taille effective du resultat}
           coupe.data[round(qvar*resol),0,0].x:=round(qvar*resol)/resol;
           inc(norm[round(qvar*resol)]);
           coupe.data[round(qvar*resol),0,0].z:=coupe.data[round(qvar*resol),0,0].z+data[i,j,0].z;
         end
         else begin
              end;
   inc(Xmax);
   {normalisation par pixel}
   for i:=0 to Xmax-1 do
       begin
       if norm[i]<>0 then coupe.data[i,0,0].z:=coupe.data[i,0,0].z/norm[i];
       end;
   End;
   {setup resultat}
   setlength(coupe.data,Xmax,1,1);
   coupe.X:=Xmax;
   coupe.Y:=1;
   coupe.Lt:=1;
   result:=coupe;
end;

//================================
//masques de spectres
{retourne un spectre de meme dim X,Y que le spectre source mais avec LT =1}
{1= point compt, 0=point masqu     }
function spectre.MasqueRectInt(x1,y1,x2,y2 :double;name: string) :spectre ;
var
   mask: spectre;
   i,j : integer;
   Xg,Xp: integer; // X le plus grand et X le plus petit
   Yg,Yp: integer; // Y le plus grand et Y le plus petit
begin
  mask:=spectre.create;
  mask.ExpCondNbr:=0;
  mask.nom:=name;
  mask.X:=X;mask.Y:=Y;mask.LT:=1;
  setlength(mask.data,X,Y,1);
  mask.clear;

  if (x1<x2)then
  begin
  Xp:=trunc(x1);Xg:=trunc(x2);end
  else begin
  Xp:=trunc(x2);Xg:=trunc(x1);end;
  if (y1<y2)then begin Yp:=trunc(y1);Yg:=trunc(y2);end
  else begin
  Yp:=trunc(y2);Yg:=trunc(y1);end;
  for i:=0 to X-1 do
    for j:=0 to Y-1 do begin
      mask.data[i,j,0].z:=1;
    end;
  for i:=Xp to Xg do
   for j:=Yp to Yg do begin
     mask.data[i,j,0].z:=0;
   end;
  result:=mask;
end;
function spectre.MasqueRectExt(x1,y1,x2,y2 :double;name: string) :spectre ;
var
   mask: spectre;
   i,j : integer;
   Xg,Xp: integer; // X le plus grand et X le plus petit
   Yg,Yp: integer; // Y le plus grand et Y le plus petit
begin
  mask:=spectre.create;
  mask.nom:=name;
  mask.ExpCondNbr:=0;
  mask.X:=X;mask.Y:=Y;mask.LT:=LT;
  setlength(mask.data,X,Y,1);
  mask.clear;

  if (x1<x2)then
  begin
  Xp:=trunc(x1);Xg:=trunc(x2);end
  else begin
  Xp:=trunc(x2);Xg:=trunc(x1);end;
  if (y1<y2)then begin Yp:=trunc(y1);Yg:=trunc(y2);end
  else begin
  Yp:=trunc(y2);Yg:=trunc(y1);end;
  for i:=0 to X-1 do
    for j:=0 to Y-1 do begin
      mask.data[i,j,0].z:=0;
    end;
  for i:=Xp to Xg do
   for j:=Yp to Yg do begin
     mask.data[i,j,0].z:=1;
   end;
  result:=mask;
end;

function spectre.MasqueCircInt(x0,y0,x1,y1 :double;name: string) :spectre ;
var
   mask: spectre;
   i,j : integer;
   R: double;
begin
  mask:=spectre.create;
  mask.nom:=name;
  mask.ExpCondNbr:=0;
  mask.X:=X;mask.Y:=Y;mask.LT:=LT;
  setlength(mask.data,X,Y,1);
  mask.clear;
  R:=sqrt(sqr(x1-x0)+sqr(y1-y0));
  for i:=0 to X-1 do
    for j:=0 to Y-1 do begin
         mask.data[i,j,0].z:=1;
      if(sqrt(sqr(i-x0)+sqr(j-y0))<=R)then
         mask.data[i,j,0].z:=0;
      end;
  result:=mask;
end;

function spectre.MasqueCircExt(x0,y0,x1,y1 :double;name: string) :spectre ;
var
   mask: spectre;
   i,j : integer;
   R: double;
begin
  mask:=spectre.create;
  mask.nom:=name;
  mask.ExpCondNbr:=0;
  mask.X:=X;mask.Y:=Y;mask.LT:=LT;
  setlength(mask.data,X,Y,1);
  mask.clear;
  R:=sqrt(sqr(x1-x0)+sqr(y1-y0));
  for i:=0 to X-1 do
    for j:=0 to Y-1 do begin
      mask.data[i,j,0].z:=1;
      if(sqrt(sqr(i-x0)+sqr(j-y0))>R)then
         mask.data[i,j,0].z:=0;
    end;
  result:=mask;
end;

function spectre.SommeCirculaireMask(Mask:spectre;Name:string;x0,y0,pas :double) :spectre; { somme circulaire }
var coupe:spectre;
    i,j:integer;
    R: double;
    norm:array of integer;
    taille,Xmax:integer;
begin
   taille:=round(sqrt(X*X+Y*Y)+1); {taille du fichier a priori}
   setlength(norm,taille);
   coupe:=spectre.create;
   coupe.ExpCondNbr:=0;
   coupe.nom:=name;
   coupe.typeX:=typeX;
   setlength(coupe.data,taille,1,1);
   coupe.clear;
   Xmax:=1; {taille reel du resultat}
   if (mask.X=X) and (mask.Y=Y) and (mask.LT=LT) then
     if (x0>=0) and (x0<=X) and (y0>=0) and (y0<=Y) then
     begin
       for i:=0 to X-1 do
         for j:=0 to Y-1 do
           if typeX='raw' then begin
             if (mask.data[i,j,0].z=1) then
               R:=sqrt(sqr(i-x0)+sqr(j-y0));
               coupe.data[round(R),0,0].x:=pas*round(R);
               if round(R)>Xmax then Xmax:=round(R);
               inc(norm[round(R)]);
               coupe.data[round(R),0,0].z:=coupe.data[round(R),0,0].z+data[i,j,0].z;
           end
           else begin
           end;
       Inc(Xmax);
   for i:=0 to Xmax-1 do
       begin
       if norm[i]<>0 then coupe.data[i,0,0].z:=coupe.data[i,0,0].z/norm[i];
       end;
   end;
   setlength(coupe.data,Xmax,1,1);
   coupe.X:=Xmax;
   coupe.Y:=1;
   coupe.Lt:=1;
   result:=coupe;
end;
{ *************************************** }
{ intgrale des coups sur le spectre      }
{ sur toutes les coordonnes              }
function spectre.total:real;
var
i,j,k:integer;
tota:real;
begin
tota:=0;
for i:=0 to X-1 do
for j:=0 to Y-1 do
for k:=0 to LT-1 do begin
tota:=data[i,j,k].z+tota;
end;
result:=tota;
end;


{ ================================================= }
{ oprations de gestion des listes de spectres      }

{----------------spectrelist------------------------}

{***********************************************
cre les 16 spectres frame}
{ PROCEDURE DEVANT DISPARATRE A TERME => UTILISER LE TYPE 3D }
procedure spectlist.createframe;
var i:integer;
begin
{creation de 16 spectres }
for i:=1 to 16 do
    begin
    indexframe[i]:=deuxd.addspectre('ACF'+inttostr(i),128,128,1);
    deuxd.spect[indexframe[i]].comment:='spectre frame';
    deuxd.spect[indexframe[i]].typex:='raw';
    deuxd.spect[indexframe[i]].typey:='raw';
    end;
end;

{ ***************************************
{ cree un nouveau spectre dans la liste des spectres }
{ OUTPUT : i1 ???                                    }
{ si le spectre existe deja dans la liste,
il est supprim et remplac par ce nouveau spectre  }
function spectlist.addspectre(nom:string;X:integer;Y:integer;LT:integer):integer;
var
i:integer;
i1:integer;
tf:boolean;
begin
i:=1;i1:=-1;tf:=false;
deletespectre(indexof(nom));
while (i<=totalspectre) and (not tf) do begin
if spect[i]=nil then begin
spect[i]:=spectre.create;
spect[i].nom:=nom;
spect[i].X:=X;
spect[i].Y:=Y;
spect[i].LT:=LT;
spect[i].ExpCondNbr:=0;
setlength(spect[i].data,X,Y,LT);
i1:=i;tf:=true;
spect[i].clear;
end;
i:=i+1;
end;
result:=i1;
end;

{***************************************
{ cree un nouveau spectre et effectue le chargement}
{ INPUT : spec, le spectre a ajouter dans la liste  }
{ OUTPUT : le spectre est ajout a la liste         }
{ REM : pas de vrifications de compatibilt 1D 2D ou 3D}
procedure spectlist.add(spec:spectre);
var
i,k,l,m:integer;
begin
i:=addspectre(spec.nom,spec.X,spec.Y,spec.LT);
if i>=1 then
begin
  spect[i].comment:=spec.comment;
  spect[i].typeX:=spec.typeX;
  spect[i].typeY:=spec.typeY;
  spect[i].typeLT:=spec.typeLT;
  spect[i].indexX:=spec.indexX;
  spect[i].indexY:=spec.indexY;
  spect[i].indexLT:=spec.indexLT;
  spect[i].moniteur:=spec.moniteur;
  spect[i].ExpCondNbr:=spec.ExpCondNbr;
  {chargement des datas}
  for k:=0 to spec.X-1 do
    for l:=0 to spec.Y-1 do
        for m:=0 to spec.LT-1 do
        spect[i].data[k,l,m]:=spec.data[k,l,m];
  {chargement des conditions exprimentales}
  if spect[i].ExpCondNbr>0 then
     begin
     setlength(spect[i].experimentalConditions,spect[i].ExpCondNbr);
     for k:=0 to spect[i].ExpCondNbr-1 do
         spect[i].experimentalConditions[k]:=spec.experimentalConditions[k];
     end;
end;
end;

{***************************************}
{ destruction d'un spectre dans la lsite des spectres }
{ INPUT : ind, l'indice du spectre dans la liste      }
procedure spectlist.deletespectre(ind:integer);
begin
if (ind>=1) and (ind<=totalspectre) then
if spect[ind]<>nil then begin
spect[ind].free;
spect[ind]:=nil;
end;
end;

{***************************************}
{ destruction d'un spectre dans la lsite des spectres }
{ INPUT : ind, l'indice du spectre dans la liste      }
procedure spectlist.delete(nom:string);
begin
     deletespectre(indexof(nom));
end;

{*************************************** }
{ simplement mise a zero du spectre  }
{ INPUT : nom, le nom (string) du spectre dans la liste }
procedure spectlist.clear(nom:string);
var
ind:integer;
begin
ind:=indexof(nom);
if ind>=0 then spect[ind].clear;
end;

{***************************************}
{ destruction de tous les pointeurs de spectres d'une liste de spectres }
procedure spectlist.free;
var
i:integer;
begin
for i:=1 to totalspectre do spect[i].free;
end;


{ *************************************** }
{ ajout d'un point dans la liste          }
{ COMPRENDRE le snes de indexX index Y    }
procedure spectlist.addpt(nom:string;x,y,lt,z,mon:extended);
var
i:integer;
tf:boolean;
begin
i:=indexof(nom);tf:=false;
if i>=0
then begin
     if spect[i].indexX>=spect[i].X-1 then begin spect[i].indexY:=spect[i].indexY+1;
     if spect[i].indexY<spect[i].Y-1 then begin  spect[i].indexX:=0;tf:=true;end;
     end
else begin
     tf:=true;
     spect[i].indexX:=spect[i].indexX+1;
     end;
if tf then begin
spect[i].data[spect[i].indexX,spect[i].indexY,spect[i].indexLT].x:=x;
spect[i].data[spect[i].indexX,spect[i].indexY,spect[i].indexLT].y:=y;
spect[i].data[spect[i].indexX,spect[i].indexY,spect[i].indexLT].lt:=lt;
spect[i].data[spect[i].indexX,spect[i].indexY,spect[i].indexLT].z:=z;
spect[i].data[spect[i].indexX,spect[i].indexY,spect[i].indexLT].mon:=mon;
end;
end;
end;

{***************************************
{  retourne l'index du spectre ou -1 si le spectre n'existe pas}
function spectlist.indexof(nom:string):integer;
var
i:integer;
i1:integer;
begin
i:=1;i1:=-1;
while (i<=totalspectre) and (i1=-1) do begin
if spect[i]<>nil then
if spect[i].nom=nom then i1:=i;
i:=i+1;
end;
result:=i1;
end;

{ Oprations arithmtiques sur les spectres}
{INPUT: nom1 et nom2 : string, qui peuvent tre des spectres de dimensions
quelconques 1 2 ou 3                                                      }
{OUTPUT: mon3 le spectre rsultat est rajut dans la liste des spectes }
{REM: Message box en cas d'oprations sur les spectres incompatibles en taille}
{on inclu mon3 dedans sinon on ne peut pas l'ajouter directement dans spectlist}
{+}
function spectlist.Addition(nom1,nom2,nom3:string):boolean;{nom3=nom2+nom1}
var
i,j,k,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i2>=1) then
   if (spect[i1].x=spect[i2].x) and (spect[i1].y=spect[i2].y) and (spect[i1].lt=spect[i2].lt)then
     begin
     if i3<1 then
       i3:=addspectre(nom3,spect[i1].x,spect[i1].y,spect[i1].lt);

     spect[i3].x:=spect[i1].x;
     spect[i3].y:=spect[i1].y;
     spect[i3].lt:=spect[i1].lt;
     setlength(spect[i3].data,spect[i3].X,spect[i3].Y,spect[i3].LT);
     spect[i3].typex:=spect[i1].typex;
     spect[i3].typey:=spect[i1].typey;
     spect[i3].typeLT:=spect[i1].typeLT;
     for i:=0 to spect[i1].x-1 do
       for j:=0 to spect[i1].y-1 do
         for k:=0 to spect[i1].lt-1 do
           begin
           spect[i3].data[i,j,0].x:=spect[i1].data[i,j,k].x;
           spect[i3].data[i,j,0].y:=spect[i1].data[i,j,k].y;
           spect[i3].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
           spect[i3].data[i,j,0].z:=spect[i1].data[i,j,k].z+spect[i2].data[i,j,k].z;
           spect[i3].data[i,j,0].mon:=spect[i1].data[i,j,k].mon+spect[i2].data[i,j,k].mon;
         end;

     tf:=true;
     end;

result:=tf;
end;
{-}
function spectlist.Soustraction(nom1,nom2,nom3:string):boolean;{nom3=nom1-nom2}
var
i,j,k,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i2>=1) then
   if (spect[i1].x=spect[i2].x) and (spect[i1].y=spect[i2].y) and (spect[i1].lt=spect[i2].lt)then
     begin
     if i3<1 then
       i3:=addspectre(nom3,spect[i1].x,spect[i1].y,spect[i1].lt);

     spect[i3].x:=spect[i1].x;
     spect[i3].y:=spect[i1].y;
     spect[i3].lt:=spect[i1].lt;
     setlength(spect[i3].data,spect[i3].X,spect[i3].Y,spect[i3].LT);
     spect[i3].typex:=spect[i1].typex;
     spect[i3].typey:=spect[i1].typey;
     spect[i3].typeLT:=spect[i1].typeLT;
     for i:=0 to spect[i1].x-1 do
       for j:=0 to spect[i1].y-1 do
         for k:=0 to spect[i1].lt-1 do
           begin
           spect[i3].data[i,j,0].x:=spect[i1].data[i,j,k].x;
           spect[i3].data[i,j,0].y:=spect[i1].data[i,j,k].y;
           spect[i3].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
           spect[i3].data[i,j,0].z:=spect[i1].data[i,j,k].z-spect[i2].data[i,j,k].z;
           spect[i3].data[i,j,0].mon:=spect[i1].data[i,j,k].mon-spect[i2].data[i,j,k].mon;
         end;

     tf:=true;
     end;

result:=tf;
end;
{*}
function spectlist.Multiplication(nom1,nom2,nom3:string):boolean;{nom1*nom2=nom3}
var
i,j,k,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i2>=1) then
   if (spect[i1].x=spect[i2].x) and (spect[i1].y=spect[i2].y) and (spect[i1].lt=spect[i2].lt)then
     begin
     if i3<1 then
       i3:=addspectre(nom3,spect[i1].x,spect[i1].y,spect[i1].lt);

     spect[i3].x:=spect[i1].x;
     spect[i3].y:=spect[i1].y;
     spect[i3].lt:=spect[i1].lt;
     setlength(spect[i3].data,spect[i3].X,spect[i3].Y,spect[i3].LT);
     spect[i3].typex:=spect[i1].typex;
     spect[i3].typey:=spect[i1].typey;
     spect[i3].typeLT:=spect[i1].typeLT;
     for i:=0 to spect[i1].x-1 do
       for j:=0 to spect[i1].y-1 do
         for k:=0 to spect[i1].lt-1 do
           begin
           spect[i3].data[i,j,0].x:=spect[i1].data[i,j,k].x;
           spect[i3].data[i,j,0].y:=spect[i1].data[i,j,k].y;
           spect[i3].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
           spect[i3].data[i,j,0].z:=spect[i1].data[i,j,k].z*spect[i2].data[i,j,k].z;
           spect[i3].data[i,j,0].mon:=spect[i1].data[i,j,k].mon*spect[i2].data[i,j,k].mon;
         end;

     tf:=true;
     end;

result:=tf;
end;
{/}
function spectlist.Division(nom1,nom2,nom3:string):boolean;{nom1/nom2=nom3}
var
i,j,k,i1,i2,i3:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
i3:=indexof(nom3);
if (i1>=1) and (i2>=1) then
   if (spect[i1].x=spect[i2].x) and (spect[i1].y=spect[i2].y) and (spect[i1].lt=spect[i2].lt)then
     begin
     if i3<1 then
       i3:=addspectre(nom3,spect[i1].x,spect[i1].y,spect[i1].lt);

     spect[i3].x:=spect[i1].x;
     spect[i3].y:=spect[i1].y;
     spect[i3].lt:=spect[i1].lt;
     setlength(spect[i3].data,spect[i3].X,spect[i3].Y,spect[i3].LT);
     spect[i3].typex:=spect[i1].typex;
     spect[i3].typey:=spect[i1].typey;
     spect[i3].typeLT:=spect[i1].typeLT;
     for i:=0 to spect[i1].x-1 do
       for j:=0 to spect[i1].y-1 do
         for k:=0 to spect[i1].lt-1 do
           begin
           spect[i3].data[i,j,0].x:=spect[i1].data[i,j,k].x;
           spect[i3].data[i,j,0].y:=spect[i1].data[i,j,k].y;
           spect[i3].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
           if (spect[i2].data[i,j,k].z<>0)then // pensez  mettre un else
             spect[i3].data[i,j,0].z:=spect[i1].data[i,j,k].z/spect[i2].data[i,j,k].z;
           if (spect[i2].data[i,j,k].mon<>0)then //idem
             spect[i3].data[i,j,0].mon:=spect[i1].data[i,j,k].mon/spect[i2].data[i,j,k].mon;
         end;

     tf:=true;
     end;

result:=tf;
end;
{*scalaire}
function spectlist.ScalMult(scalaire:real;nom1,nom2: string): boolean; {nom1=nom2*scalaire}
var
i,j,k,i1,i2:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
if (scalaire<>0)then
  if (i1>=1)then
  begin
     if i2<1 then
       i2:=addspectre(nom2,spect[i1].x,spect[i1].y,spect[i1].lt);
       spect[i2].x:=spect[i1].x;
       spect[i2].y:=spect[i1].y;
       spect[i2].lt:=spect[i1].lt;
       setlength(spect[i2].data,spect[i2].X,spect[i2].Y,spect[i2].LT);
       spect[i2].typex:=spect[i1].typex;
       spect[i2].typey:=spect[i1].typey;
       spect[i2].typeLT:=spect[i1].typeLT;
       for i:=0 to spect[i1].x-1 do
         for j:=0 to spect[i1].y-1 do
           for k:=0 to spect[i1].lt-1 do
           begin
             spect[i2].data[i,j,0].x:=spect[i1].data[i,j,k].x;
             spect[i2].data[i,j,0].y:=spect[i1].data[i,j,k].y;
             spect[i2].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
             spect[i2].data[i,j,0].z:=spect[i1].data[i,j,k].z*scalaire;
             spect[i2].data[i,j,0].mon:=spect[i1].data[i,j,k].mon{*scalaire;???};
          end;
      tf:=true;
     end;
result:=tf;
end;
{/scalaire}
function Spectlist.ScalDiv(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1/scalaire}
var
i,j,k,i1,i2:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
if (scalaire<>0)then
  if (i1>=1)then
  begin
     if i2<1 then
       i2:=addspectre(nom2,spect[i1].x,spect[i1].y,spect[i1].lt);
       spect[i2].x:=spect[i1].x;
       spect[i2].y:=spect[i1].y;
       spect[i2].lt:=spect[i1].lt;
       setlength(spect[i2].data,spect[i2].X,spect[i2].Y,spect[i2].LT);
       spect[i2].typex:=spect[i1].typex;
       spect[i2].typey:=spect[i1].typey;
       spect[i2].typeLT:=spect[i1].typeLT;
       for i:=0 to spect[i1].x-1 do
         for j:=0 to spect[i1].y-1 do
           for k:=0 to spect[i1].lt-1 do
           begin
             spect[i2].data[i,j,0].x:=spect[i1].data[i,j,k].x;
             spect[i2].data[i,j,0].y:=spect[i1].data[i,j,k].y;
             spect[i2].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
             spect[i2].data[i,j,0].z:=spect[i1].data[i,j,k].z/scalaire;
             spect[i2].data[i,j,0].mon:=spect[i1].data[i,j,k].mon{/scalaire;???};
          end;
      tf:=true;
     end;
result:=tf;
end;
{+scalaire}
function Spectlist.ScalAdd(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1+scalaire}
var
i,j,k,i1,i2:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
  if (i1>=1)then
  begin
     if i2<1 then
       i2:=addspectre(nom2,spect[i1].x,spect[i1].y,spect[i1].lt);
       spect[i2].x:=spect[i1].x;
       spect[i2].y:=spect[i1].y;
       spect[i2].lt:=spect[i1].lt;
       setlength(spect[i2].data,spect[i2].X,spect[i2].Y,spect[i2].LT);
       spect[i2].typex:=spect[i1].typex;
       spect[i2].typey:=spect[i1].typey;
       spect[i2].typeLT:=spect[i1].typeLT;
       for i:=0 to spect[i1].x-1 do
         for j:=0 to spect[i1].y-1 do
           for k:=0 to spect[i1].lt-1 do
           begin
             spect[i2].data[i,j,0].x:=spect[i1].data[i,j,k].x;
             spect[i2].data[i,j,0].y:=spect[i1].data[i,j,k].y;
             spect[i2].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
             spect[i2].data[i,j,0].z:=spect[i1].data[i,j,k].z+scalaire;
             spect[i2].data[i,j,0].mon:=spect[i1].data[i,j,k].mon{+scalaire;???};
          end;
      tf:=true;
     end;
result:=tf;
end;
{-scalaire}
function Spectlist.ScalSub(scalaire:real;nom1,nom2: string): boolean; {nom2=nom1-scalaire}
var
i,j,k,i1,i2:integer;
tf:boolean;
begin
tf:=false;
i1:=indexof(nom1);
i2:=indexof(nom2);
  if (i1>=1)then
  begin
     if i2<1 then
       i2:=addspectre(nom2,spect[i1].x,spect[i1].y,spect[i1].lt);
       spect[i2].x:=spect[i1].x;
       spect[i2].y:=spect[i1].y;
       spect[i2].lt:=spect[i1].lt;
       setlength(spect[i2].data,spect[i2].X,spect[i2].Y,spect[i2].LT);
       spect[i2].typex:=spect[i1].typex;
       spect[i2].typey:=spect[i1].typey;
       spect[i2].typeLT:=spect[i1].typeLT;
       for i:=0 to spect[i1].x-1 do
         for j:=0 to spect[i1].y-1 do
           for k:=0 to spect[i1].lt-1 do
           begin
             spect[i2].data[i,j,0].x:=spect[i1].data[i,j,k].x;
             spect[i2].data[i,j,0].y:=spect[i1].data[i,j,k].y;
             spect[i2].data[i,j,0].lt:=spect[i1].data[i,j,k].lt;
             spect[i2].data[i,j,0].z:=spect[i1].data[i,j,k].z-scalaire;
             spect[i2].data[i,j,0].mon:=spect[i1].data[i,j,k].mon{-scalaire;???};
          end;
      tf:=true;
     end;
result:=tf;
end;

{on se sert du parser en remplacant les variables par la
valeur dans la chane
pour chaque chane on rentre le nom (remplac par [i,j])
on peut rentrer le nommon (remplac par le moniteur) ou le
nomtemps remplac par le temps}
function spectlist.parsechaine(s:string):boolean;{traite la chane du type nom3=f(nom1,nom2)}
var
  s2,s1:string;
  s3:array[1..10] of string;
  uu3:array[1..10] of integer;
  m,i,j,x,y,lt,k,l:integer;
  i1:integer;
  typx,typy:string;
begin
for i:=1 to 10 do s3[i]:='';
j:=1;x:=0;y:=0;lt:=0;
for i:=1 to totalspectre do if spect[i]<>nil then
 if pos(spect[i].nom,s)>0 then begin
 s3[j]:=spect[i].nom;uu3[j]:=i;j:=j+1;
  x:=spect[i].x;y:=spect[i].y;lt:=spect[i].lt;
  typx:=spect[i].typex;typy:=spect[i].typey;
 end;
if (pos('=',s)>0) and (x>0) and (y>0) then begin
s2:=copy(s,pos('=',s)+1,length(s));
s1:=copy(s,1,pos('=',s)-1);
i1:=indexof(s1);
if i1<0 then begin
i1:=addspectre(s1,x,y,lt);
spect[i1].typex:=typx;
spect[i1].typey:=typy;
end;
for k:=0 to x-1 do
for l:=0 to y-1 do begin
dataeditform.parser1.setvariable('i',k);
dataeditform.parser1.setvariable('j',l);
for m:=0 to 9 do begin
i:=m+1;
if s3[i]<>'' then begin
dataeditform.parser1.setvariable(s3[i],spect[uu3[i]].data[k,l,0].z);
dataeditform.parser1.setvariable(s3[i]+'mon',spect[uu3[i]].data[k,l,0].mon);
end;
end;
dataeditform.parser1.expression:=s2;
spect[i1].data[k,l,0].z:=dataeditform.parser1.value;
end;
end;
result:=true;
end;

procedure spectlist.saveall;
var
i:integer;
begin
i:=1;
while (i<=totalspectre)do begin
if spect[i]<>nil then spect[i].savetofile(spect[i].nom);
i:=i+1;
end;
end;

{ ===================================================== }
{ PROCEDURES LIEES A LA GESTION DE LA FENETRE           }
{----------------------tdataeditform--------------------}
procedure Tdataeditform.ComboBox1Change(Sender: TObject);
var
ind,i,j:integer;
begin
if unddeud=false then begin
ind:=deuxd.indexof(combobox1.text);
if ind>=1 then begin
editX.text:=inttostr(deuxd.spect[ind].X);
editY.text:=inttostr(deuxd.spect[ind].Y);
edittypx.text:=deuxd.spect[ind].typeX;
edittypy.text:=deuxd.spect[ind].typeY;
editnom.text:=deuxd.spect[ind].nom;
editcom.text:=deuxd.spect[ind].comment;
for i:=1 to deuxd.spect[ind].x do
for j:=1 to deuxd.spect[ind].y do begin

end;

end;
end else begin
ind:=und.indexof(combobox1.text);
if ind>=1 then begin
editX.text:=inttostr(und.spect[ind].X);
editY.text:=inttostr(und.spect[ind].Y);
edittypx.text:=und.spect[ind].typeX;
edittypy.text:=und.spect[ind].typeY;
editnom.text:=und.spect[ind].nom;
editcom.text:=und.spect[ind].comment;
end;
end;
end;

procedure Tdataeditform.FormCreate(Sender: TObject);
var
i:integer;
begin
unddeud:=true;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
begin
combobox1.items.add(und.spect[i].nom);
end;
top:=0;left:=0;width:=300;height:=300;
update;
WindowState:=wsMinimized;
end;

procedure Tdataeditform.F1Book1EndEdit(Sender: TObject;
  var EditString: WideString; var Cancel: Smallint);
var
ind,i,j:integer;
u:real;
begin
if unddeud=true then begin
ind:=und.indexof(combobox1.text);
if ind>=1 then begin
u:=strtofloat(editstring);
if j=1 then und.spect[ind].data[i-1,0,0].mon:=u;
if j=2 then und.spect[ind].data[i-1,0,0].x:=u;
if j=3 then und.spect[ind].data[i-1,0,0].z:=u;
end;
end else begin
ind:=deuxd.indexof(combobox1.text);
if ind>=1 then begin
u:=strtofloat(editstring);
deuxd.spect[ind].data[i-1,j-1,0].z:=u;
end;
end;
end;

procedure Tdataeditform.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=13 then traitchaine(edit1.text);
end;

procedure Tdataeditform.traitchaine(s:string);
var
i:integer;
begin
if unddeud=true then begin
und.parsechaine(s);
combobox1.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
combobox1.items.add(und.spect[i].nom);
end else begin
deuxd.parsechaine(s);
combobox1.clear;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
combobox1.items.add(deuxd.spect[i].nom);
end;
end;

procedure Tdataeditform.RadioGroup1Click(Sender: TObject);
var
i:integer;
begin
if radiogroup1.itemindex=0 then unddeud:=true else unddeud:=false;
if unddeud=true then begin
combobox1.clear;
for i:=1 to totalspectre do
if und.spect[i]<>nil then
combobox1.items.add(und.spect[i].nom);
end else begin
combobox1.clear;
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
combobox1.items.add(deuxd.spect[i].nom);
end;
combobox1.itemindex:=0;
end;

procedure Tdataeditform.sauve(i:integer;nom:string);
begin
if (nom<>'tout') then begin
if i=1 then
if und.indexof(nom)>=0 then
und.spect[und.indexof(nom)].savetofile(nom);
if i=2 then
if deuxd.indexof(nom)>=0 then
deuxd.spect[deuxd.indexof(nom)].savetofile(nom);
end else begin
if i=1 then und.saveall;
if i=2 then deuxd.saveall;
end;
end;

{procdure de lecture d'un spectre  partir du disque dur }
{ INPUT : le nom du fichier                               }
procedure TdataEditForm.litSpectre1D(s:string);
begin
und.spect[1].readfromfile(boitnoir.RepertoireManip.text+'\'+s);
end;

procedure TdataEditForm.litSpectre2D(s:string);
begin
deuxd.spect[1].readfromfile(boitnoir.RepertoireManip.text+'\'+s);
end;

procedure Tdataeditform.SpeedButton2Click(Sender: TObject);
begin
if unddeud then sauve(1,combobox1.text)
else sauve(2,combobox1.text);
end;

procedure Tdataeditform.SpeedButton3Click(Sender: TObject);
begin
if unddeud then sauve(1,'tout')
else sauve(2,'tout');
end;

procedure Tdataeditform.SpeedButton5Click(Sender: TObject);
begin
if unddeud then und.deletespectre(und.indexof(combobox1.text))
else deuxd.deletespectre(deuxd.indexof(combobox1.text));
radiogroup1click(Sender);
end;

procedure Tdataeditform.SpeedButton4Click(Sender: TObject);
var
spec:spectre;
begin
spec:=spectre.create;
opendialog1.initialdir:=defaultdir;
if opendialog1.execute then
begin
spec.readfromfile(opendialog1.filename);
if spec.typey='single' then und.add(spec) else deuxd.add(spec);
end;
spec.Destroy;
end;

procedure Tdataeditform.EdittypXChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].typeX:=edittypX.text
else deuxd.spect[deuxd.indexof(combobox1.text)].typeX:=edittypX.text;
end;

procedure Tdataeditform.EdittypYChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].typeY:=edittypY.text
else deuxd.spect[deuxd.indexof(combobox1.text)].typeY:=edittypY.text;
end;

procedure Tdataeditform.EditnomChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].nom:=editnom.text
else deuxd.spect[deuxd.indexof(combobox1.text)].nom:=editnom.text;
ComboBox1Change(Sender);
end;

procedure Tdataeditform.EditcomChange(Sender: TObject);
begin
if unddeud then und.spect[und.indexof(combobox1.text)].comment:=editcom.text
else deuxd.spect[deuxd.indexof(combobox1.text)].comment:=editcom.text;
end;

procedure Tdataeditform.ComboBox1DropDown(Sender: TObject);
var i:integer;
begin
{reinitialisation des items a chaque ouverture du combo}
combobox1.items.clear;

for i:=1 to totalspectre do
begin
if deuxd<>nil then
if deuxd.spect[i]<>nil then
   combobox1.items.add(deuxd.spect[i].nom);

if und<>nil then
if und.spect[i]<>nil then
   combobox1.items.add(und.spect[i].nom);
end;
end;


end.